<?php
/*
Plugin Name: XmasB Quotes
Plugin URI: http://xmasb.com/xmasbquotes
Description: Add quotes with images to your wordpress blog
Version: 1.1.2
Author: XmasB
Author URI: http://xmasb.com
*/

/*  Copyright YEAR  PLUGIN_AUTHOR_NAME  (email : PLUGIN AUTHOR EMAIL)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('XMASB_QUOTES_TABLE', $table_prefix . 'xmasb_quotes');

function filter_xmasb_quotes_random_quote($content) {
    $codetoreplace = "[XmasBRandomQuote]";
    $content=str_replace($codetoreplace,xmasb_get_random_quote(),$content);
    $content=str_replace($codetoreplace,xmasb_get_random_quote(),$content);
    return $content;
}

function xmasb_quotes_install ()
{
	global $wpdb;

	$sql = "CREATE TABLE " . XMASB_QUOTES_TABLE . " (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		author tinytext NOT NULL default '',
		quote text NOT NULL,
		imgsrc tinytext NOT NULL default '',
		visible boolean NOT NULL default 1,
		UNIQUE KEY id (id)
		);";

	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	dbDelta($sql);
	
	load_plugin_textdomain('xmasb-quotes');
}
function xmasb_quotes_print_showlink()
{
	echo xmasb_quotes_get_showlink();
}

function xmasb_quotes_get_showlink()
{
	$options = get_option('widget_xmasb_quotes');
	$showlink = $options['showlink'] == 'yes' ? true : false;
	if ( $showlink ) return '<div class="xmasb_quotes_link"><a href="http://xmasb.com/xmasbquotes">XmasB Quotes</a> by <a href="http://xmasb.com">XmasB</a></div>';
	return '';
}

function xmasb_quotes_print_showimage($quoteimg, $quote)
{
		echo xmasb_quotes_get_showimage($quoteimg, $quote);
}

function xmasb_quotes_get_showimage($quoteimg, $quote)
{
		$siteurl = get_option("siteurl");
		if ($siteurl[strlen($siteurl)-1] != "/") $siteurl .= "/";
		return '<div class="xmasb_quotes_image">
			<img src="'. $siteurl . $quoteimg . '" alt="' . $quote->author . '" />
			</div>';
}

function xmasb_print_random_quote()
{
	echo xmasb_get_random_quote();
}

function xmasb_get_random_quote()
{
	$return = "";
	global $wpdb;
	$table_name = $wpdb->prefix . "xmasb_quotes";
	$sql = "SELECT * FROM " . XMASB_QUOTES_TABLE . " where visible = 1 ORDER BY RAND() limit 1";
	$quotes = $wpdb->get_results($sql);
	
	if ( !empty($quotes) )
	{
		$return .= xmasb_quotes_get_quote($quotes[0], true);
		$return .= xmasb_quotes_get_showlink();
	}
	else
	{
		$return .=  _e("No quotes found");
	}
	return $return;
}

function xmasb_quotes_print_quote($quote, $showimage = false)
{
	echo xmasb_quotes_get_quote($quote, $showimage = false);
}

function xmasb_quotes_get_quote($quote, $showimage = false)
{
	$return = "";
	if (is_plugin_page())
	{
		$return .= '<form action="" method="post">';
	}
	$options = get_option('widget_xmasb_quotes');
	$showimages = htmlspecialchars($options['showimages'], ENT_QUOTES) == 'yes' ? true : false;
	$plugin_path = "wp-content/plugins/" . dirname(plugin_basename(__FILE__)) . "/";
	$imagelocation = $plugin_path . "images/";
	$defaultimage = htmlspecialchars($options['defaultimage'], ENT_QUOTES);
	$htmlbeforeimage = $options['htmlbeforeimage'];
	$htmlafterimage = $options['htmlafterimage'];
	$htmlbeforequote = $options['htmlbeforequote'];
	$htmlafterquote = $options['htmlafterquote'];
	$htmlbeforeauthor = $options['htmlbeforeauthor'];
	$htmlafterauthor = $options['htmlafterauthor'];

	$codeforimage = "";
	if ( $showimage && $showimages)
	{
		if (empty($quote->imgsrc))
		{
			$quoteimg = $imagelocation . $quote->author . '.gif';
			if (file_exists($quoteimg))
			{
				$codeforimage .= xmasb_quotes_get_showimage($quoteimg, $quote);
			}
			elseif (!empty($defaultimage))
			{
				$codeforimage .= '<!-- XmasB Quotes: Image "' . $quoteimg . '" (by author) not found. -->';
				$quoteimg = $imagelocation . $defaultimage;
				if (file_exists($quoteimg))
				{
					$codeforimage .= xmasb_quotes_get_showimage($quoteimg, $quote);
				}
				else
				{
					$codeforimage .= '<!-- XmasB Quotes: Default Image "' . $quoteimg . '" not found. -->';
				}
			}
			else
			{
				$codeforimage .= '<!-- XmasB Quotes: Image "' . $quoteimg . '" (by author) not found. -->';
			}
		}
		else
		{
			$quoteimg = $imagelocation . $quote->imgsrc;
			if (file_exists($quoteimg))
			{
				$codeforimage .= xmasb_quotes_get_showimage($quoteimg, $quote);
			}
			elseif (!empty($defaultimage))
			{
				$codeforimage .= '<!-- XmasB Quotes: Image "' . $quoteimg . '" (by author) not found. -->';
				$quoteimg = $imagelocation . $defaultimage;
				if (file_exists($quoteimg))
				{
					$codeforimage .= xmasb_quotes_get_showimage($quoteimg, $quote);
				}
				else
				{
					$codeforimage .= '<!-- XmasB Quotes: Default Image "' . $quoteimg . '" not found. -->';
				}
			}
			else
			{
				$codeforimage .= '<!-- XmasB Quotes: Image "' . $quoteimg . '" specified for quoteid ' . $quote->id . ' not found. -->';
			}
		}
	}
	if ( !empty($codeforimage) )
	{
		$return .= $htmlbeforeimage . $codeforimage . $htmlafterimage;
	}
	
	if (is_plugin_page())
	{
		$codeforquote = "";
		if ( $quote->visible )
		{
			$codeforquote .= '<div class="xmasb_quotes_quote">' . $quote->quote . '</div>';
		}
		else
		{
			$codeforquote .= '<div class="xmasb_quote_not_visible">' . $quote->quote . '</div>';
		}
		if ( !empty($codeforquote) )
		{
			$return .= $codeforquote;
		}
	}
	else
	{
		$return .= '<div class="xmasb_quotes_quote">' . $htmlbeforequote . $quote->quote . $htmlafterquote . '</div>';
	}
	
	if ( !empty($quote->author) )
	{
		if (is_plugin_page())
		{
			$return .= '<div class="xmasb_quotes_author"><strong>' . $quote->author . '</strong></div>';
		}
		else
		{
			$return .= '<div class="xmasb_quotes_author"><strong>' . $htmlbeforeauthor . $quote->author . $htmlafterauthor . '</strong></div>';
		}
	}
	if (is_plugin_page())
	{
		if ( !empty($quote->imgsrc) )
		{
			$return .= '<div class="xmasb_quotes_imgsrc"><strong>' . $quote->imgsrc . '</strong></div>';
		}
			$return .= '<form action="" method="post">
		<input type="hidden" name="mode" value="edit">
		<input type="hidden" value="' . $quote->id . '" name="quoteID"/>
		<input class="button" type="submit" value="' . __('Edit') . '" name="Submit"/>
		<input class="button" type="submit" onclick="return delete_confirmation_xmasb_quotes()" value="Delete" name="mode"/>
		</form>';
	}
	return $return;
}

function xmasb_quotes_options_page()
{
	$options = get_option('widget_xmasb_quotes');
	if ( !is_array($options) )
		$options = array('title'=>'XmasB Quotes', 'showimages'=>'yes', 'defaultimage'=>'quote.gif', 'showlink'=>'yes', 'htmlbeforequote'=>'<q>', 'htmlafterquote'=>'</q>');
	if ( $_POST['xmasb_quotes-submit'] )
	{
		$options['showimages'] = strip_tags(stripslashes($_POST['xmasb_quotes-showimages']));
		$options['defaultimage'] = strip_tags(stripslashes($_POST['xmasb_quotes-defaultimage']));
		$options['showlink'] = strip_tags(stripslashes($_POST['xmasb_quotes-showlink']));
		$options['htmlbeforeimage'] = $_POST['xmasb_quotes-htmlbeforeimage'];
		$options['htmlafterimage'] = $_POST['xmasb_quotes-htmlafterimage'];
		$options['htmlbeforequote'] = $_POST['xmasb_quotes-htmlbeforequote'];
		$options['htmlafterquote'] = $_POST['xmasb_quotes-htmlafterquote'];
		$options['htmlbeforeauthor'] = $_POST['xmasb_quotes-htmlbeforeauthor'];
		$options['htmlafterauthor'] = $_POST['xmasb_quotes-htmlafterauthor'];
		update_option('widget_xmasb_quotes', $options);
	}

	$showimages = htmlspecialchars($options['showimages'], ENT_QUOTES);
	$defaultimage = htmlspecialchars($options['defaultimage'], ENT_QUOTES);
	$showlink = htmlspecialchars($options['showlink'], ENT_QUOTES);
	$htmlbeforeimage = $options['htmlbeforeimage'];
	$htmlafterimage = $options['htmlafterimage'];
	$htmlbeforequote = $options['htmlbeforequote'];
	$htmlafterquote = $options['htmlafterquote'];
	$htmlbeforeauthor = $options['htmlbeforeauthor'];
	$htmlafterauthor = $options['htmlafterauthor'];
	
	?>
	<div class="wrap">
		<h2>XmasB Quotes</h2>
		<form name="quoteform" id="quoteform" class="wrap" method="post" action="">
			<?php wp_nonce_field('update-options') ?>
			<table class="optiontable">
				<tbody>
					<tr valign="top">
						<th scope="row"><?php _e('Show images', 'xmasb-quotes'); ?></th>
						<td>
							<input type="radio" name="xmasb_quotes-showimages" class="input" value="yes" <?php echo $showimages == 'yes' ? 'checked="yes"' : '' ?> /> <?php _e('Yes'); ?>
							<input type="radio" name="xmasb_quotes-showimages" class="input" value="no" <?php echo $showimages != 'yes' ? 'checked="yes"' : '' ?> /> <?php _e('No'); ?>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Default image'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-defaultimage" name="xmasb_quotes-defaultimage" type="text" value="<?php echo $defaultimage; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('Show link to author'); ?></th>
						<td>
							<input type="radio" name="xmasb_quotes-showlink" class="input" value="yes" <?php echo $showlink == 'yes' ? 'checked="yes"' : '' ?> /> <?php _e('Yes'); ?>
							<input type="radio" name="xmasb_quotes-showlink" class="input" value="no" <?php echo $showlink != 'yes' ? 'checked="yes"' : '' ?> /> <?php _e('No'); ?>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML before image'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlbeforeimage" name="xmasb_quotes-htmlbeforeimage" type="text" value="<?php echo $htmlbeforeimage; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML after image'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlafterimage" name="xmasb_quotes-htmlafterimage" type="text" value="<?php echo $htmlafterimage; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML before quote'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlbeforequote" name="xmasb_quotes-htmlbeforequote" type="text" value="<?php echo $htmlbeforequote; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML after quote'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlafterquote" name="xmasb_quotes-htmlafterquote" type="text" value="<?php echo $htmlafterquote; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML before author'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlbeforeauthor" name="xmasb_quotes-htmlbeforeauthor" type="text" value="<?php echo $htmlbeforeauthor; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php _e('HTML after aturhor'); ?></th>
						<td>
							<input style="width: 200px;" id="xmasb_quotes-htmlafterauthor" name="xmasb_quotes-htmlafterauthor" type="text" value="<?php echo $htmlafterauthor; ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" />
						<td>
							<input class="button bold" type="submit" value="<?php _e('Save'); ?>" name="Submit" />
						</td>
					</tr>
				</tbody>
			</table>
			<input type="hidden" id="xmasb_quotes-submit" name="xmasb_quotes-submit" value="1" />
		</form>
	</div>
	<?php
}

function xmasb_quotes_management_page()
{
	global $wpdb;
	$data = false;

	$mode = !empty($_REQUEST['mode']) ? $_REQUEST['mode'] : '';
	$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';
	
	if (empty($quoteID))
	{
		$quoteID = false;
	}
	
	if ( empty($mode) )
	{
		$mode = 'new';
	}
	if ($mode == 'add')
	{
		$quote = !empty($_REQUEST['quote_quote']) ? $_REQUEST['quote_quote'] : '';
		$author = !empty($_REQUEST['quote_author']) ? $_REQUEST['quote_author'] : '';
		$imgsrc = !empty($_REQUEST['quote_imgsrc']) ? $_REQUEST['quote_imgsrc'] : '';
		$visible = !empty($_REQUEST['quote_visible']) ? $_REQUEST['quote_visible'] : '';
		
		if ( ini_get('magic_quotes_gpc') )
		{
			$quote = stripslashes($quote);
			$author = stripslashes($author);
			$imgsrc = stripslashes($imgsrc);
		}	

		if (empty($quote))
		{
				?>
					<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong><?php _e('Could not add quote. No quote entered.')?></strong></p></div>
				<?php
		}
		else
		{
			$sql = "select * from " . XMASB_QUOTES_TABLE . "
				where quote = '" . mysql_real_escape_string($quote) . "'
				and author = '" . mysql_real_escape_string($author) . "'";
			$sqlresponse = $wpdb->query($sql);

			if ( $sqlresponse > 0 )
			{
				if (empty($author))
				{
					?>
						<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong><?php _e('Could not add quote "' . $quote . '". Quote already exists without author.')?></strong></p></div>
					<?php
				}
				else
				{
					?>
						<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong><?php _e('Could not add quote "' . $quote . '". Quote already exists for author "' . $author . '".')?></strong></p></div>
					<?php
				}
			}
			else
			{
				$sql = "insert into " . XMASB_QUOTES_TABLE . " set "
					. "quote='" . mysql_real_escape_string($quote) . "', "
					. "author='" . mysql_real_escape_string($author) . "', "
					. "imgsrc='" . mysql_real_escape_string($imgsrc) . "', "
					. "visible='" . mysql_real_escape_string($visible) . "'";
				$sqlresponse = $wpdb->query($sql);
				if ( $sqlresponse == 1 )
				{
					$sql = "select id from " . XMASB_QUOTES_TABLE . " where quote='" . mysql_real_escape_string($quote) . "'"
				     . " and author='" . mysql_real_escape_string($author) . "' and visible='" . mysql_real_escape_string($visible) . "' limit 1";
					$quotes = $wpdb->get_results($sql);
					if ( empty($quotes) || empty($quotes[0]->id) )
					{
						?>
								<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Unknown Error Occured</strong></p></div>
						<?php
					}
					else
					{
						?>
								<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Quote has been added with id <?php echo $quotes[0]->id?>.</strong></p></div>
						<?php
						$quote = false;
					}
				}
				else if ( $sqlresponse > 1 )
				{
				?>
						<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>All hell is lose. <?php echo $sqlresponse?> quotes added!</strong></p></div>
				<?php
				}
			}
		}
	}
	else if ( $mode == 'list' )
	{
		$sql = 'SELECT COUNT(*) AS count FROM ' . XMASB_QUOTES_TABLE;
		$numberofquotes = $wpdb->get_results($sql);
		$sql = 'SELECT * FROM ' . XMASB_QUOTES_TABLE . ' ORDER BY author';
		$quotes = $wpdb->get_results($sql);
		if ( empty($quotes))
		{
			echo "No quotes found!";
			$mode = "new";
		}
		else
		{
			?>
			<div class="wrap">
			<h2>XmasB Quotes</h2>
			<div class="xmasb_quotes_block"><ul class="xmasb_quotes_list">
			<legend><?php _e('Number of quotes','xmasb_quotes')?>: <?php echo $numberofquotes[0]->count ?></legend>
			<form name="quotelist" id="quotelist" method="post" action="">
				<input type="hidden" name="mode" value="new">
				<input class="button" type="submit" value="<?php _e('Add new') ?>" name="Submit"/>
			</form>
			<br />
		<?php
			foreach ($quotes as $quote)
			{
				echo "<li>";
				xmasb_quotes_print_quote($quote);
				echo "</li>";
			}
			?></ul></div><?php
		}
	}
	else if ( $mode == 'edit' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';	
	}
	else if ( $mode == 'edited' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';	
		$quote = !empty($_REQUEST['quote_quote']) ? $_REQUEST['quote_quote'] : '';
		$author = !empty($_REQUEST['quote_author']) ? $_REQUEST['quote_author'] : '';
		$imgsrc = !empty($_REQUEST['quote_imgsrc']) ? $_REQUEST['quote_imgsrc'] : '';
		$visible = !empty($_REQUEST['quote_visible']) ? $_REQUEST['quote_visible'] : '';

		if ( ini_get('magic_quotes_gpc') )
		{
			$quote = stripslashes($quote);
			$author = stripslashes($author);
			$imgsrc = stripslashes($imgsrc);
		}	

		$sql = "update " . XMASB_QUOTES_TABLE . " set quote='" . mysql_real_escape_string($quote) . "', "
			. "author='" . mysql_real_escape_string($author). "', "
			. "imgsrc='" . mysql_real_escape_string($imgsrc). "', "
			. "visible='" . mysql_real_escape_string($visible) . "'"
		  . " where id='" . mysql_real_escape_string($quoteID) . "'";
		$sqlresponse = $wpdb->query($sql);
		if ( $sqlresponse == 1 )
		{
		?>
				<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Quote has been edited.</strong></p></div>
		<?php
			$quoteID = false;
		}
		else
		{
		?>
			<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Could not edit quote.</strong></p></div>
		<?php
			$mode = 'edit';
		}
	}
	else if ( $mode == 'Delete' )
	{
		$quoteID = !empty($_REQUEST['quoteID']) ? $_REQUEST['quoteID'] : '';
		if ( empty($quoteID) )
		{
			?>
			<div class="error"><p><strong>Failure:</strong> No quote ID given.</p></div>
			<?php			
		}
		else
		{
			$sql = "delete from " . XMASB_QUOTES_TABLE . " where id='" . mysql_escape_string($quoteID) . "'";
			$sqlresponse = $wpdb->query($sql);

			if ( $sqlresponse == 1 )
			{
				?>
				<div class="updated"><p>Quote <?php echo $quoteID;?> deleted successfully</p></div>
				<?php
			}
			else
			{
				?>
				<div class="error"><p><strong>Failure:</strong> Could not delete quote.</p></div>
				<?php
			}
		}
		$quoteID = false;
	}
	else if ( $mode == 'new' ) { }
	else{	echo "<p>Mode: " . $mode . "</p>"; }

	if ( $quoteID !== false )
	{
		if ( intval($quoteID) != $quoteID )
		{
		?>
		<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>WTH?!?</strong></p></div>
		<?php
			return;
		}
		else
		{
			$quote = $wpdb->get_results("select * from " . XMASB_QUOTES_TABLE . " where id='" . mysql_real_escape_string($quoteID) . "' limit 1");
			if ( empty($quote) )
			{
			?>
			<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>No quote found for id <?php echo $quoteID?></strong></p></div>
			<?php
				return;
			}
			$quote = $quote[0];
		}
	}
	if ( $mode != "list" )
	{
		?>
		<div class="wrap">
			<h2>XmasB Quotes</h2>
			<fieldset class="options">
			<?php
				if ($mode=="new" || $mode=="add" || $mode=="edited" || $mode=="Delete"){
			?><legend><?php _e('Add New Quote') ?></legend><?php
				}elseif ($mode=="edit"){
			?><legend><?php _e('Edit Quote') ?></legend><?php
				}else{
			?><legend>WTF?!? <?php echo $mode ?></legend>
			<?php } ?>
			<form name="quoteform" id="quoteform" class="options" method="post" action="">
				<?php wp_nonce_field('update-options') ?>
				<input type="hidden" name="mode" value="<?php echo $mode=="edit" ? "edited" : "add" ?>">
				<input type="hidden" value="<?php echo $quote->id; ?>" name="quoteID"/>
				<table class="optiontable">
					<tbody>
						<tr valign="top">
							<th scope="row"><?php _e('Quote'); ?></th>
							<td>
								<textarea name="quote_quote" class="input" cols=50 rows=7><?php if ( !empty($quote) ) echo htmlspecialchars($quote->quote); ?></textarea>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row"><?php _e('Author'); ?> (<?php _e('Optional') ?>)</th>
							<td>
								<input class="input" type="text" name="quote_author" value="<?php if ( !empty($quote) ) echo htmlspecialchars($quote->author); ?>" size="52" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row"><?php _e('Image'); ?> (<?php _e('Optional') ?>)</th>
							<td>
								<input class="input" type="text" name="quote_imgsrc" value="<?php if ( !empty($quote) ) echo htmlspecialchars($quote->imgsrc); ?>" size="52" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row"><?php _e('Visible'); ?></th>
							<td>
								<input type="radio" name="quote_visible" class="input" value="1" <?php if ( empty($quote->quote) || $quote->visible==1 ) echo "checked" ?> /> <?php _e('Yes'); ?>
								<input type="radio" name="quote_visible" class="input" value="0" <?php if ( !empty($quote->quote) && $quote->visible==0 ) echo "checked" ?> /> <?php _e('No'); ?>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row" />
							<td>
								<input class="button bold" type="submit" value="<?php $mode=='edit' ? _e('Edit') : _e('Add New Quote') ?>" name="Submit" />
									<?php 
										if ( $mode == "edit" )
										{
											?><input class="button" type="submit" onclick="return delete_confirmation_xmasb_quotes()" value="Delete" name="mode"/><?php
										}
									?>
								<input class="button bold" type="reset" value="<?php _e('Reset') ?>" />
							</td>
						</tr>
					</tbody>
				</table>
			</form>
			</fieldset>
			<fieldset class="options">
			<legend><?php _e('Statistics') ?></legend>
			<?php
			$sql = "SELECT * FROM " . XMASB_QUOTES_TABLE . " order by id desc limit 5";
			$quotes = $wpdb->get_results($sql);
			if ( empty($quotes))
			{
				_e('No quotes found!');
			}
			else
			{
				?><strong><?php _e('Last 5 quotes added') ?></strong>
				<div class="xmasb_quotes_block">
				<ul class="xmasb_quotes_list"><?php
				foreach ($quotes as $quote)
				{
					echo "<li>";
					xmasb_quotes_print_quote($quote);
					echo "</li>";
				}
				?></ul>
				</div><?php
					
					$sql = "SELECT COUNT(*) AS count FROM " . XMASB_QUOTES_TABLE;
					$numberofquotes = $wpdb->get_results($sql);
				?>
				<form name="quotelist" id="quotelist" method="post" action="">
					<input type="hidden" name="mode" value="list">
					<input class="button" type="submit" value="<?php echo sprintf(__('Show all %1$d quotes','my-plugin'),$numberofquotes[0]->count) ?>" name="Submit"/>
				</form>
				<?php
			}
			?>
			</fieldset>
		<?php
		$sql = 'SELECT quote
			FROM ' . XMASB_QUOTES_TABLE . '
			GROUP by quote
			HAVING COUNT(quote)>1';
		$duplicates = $wpdb->get_results($sql);
		if (!empty($duplicates))
		{
			?>
			<fieldset class="options">
			<legend><?php _e('Duplicates') ?></legend>
			<div class="xmasb_quotes_block">
			<ul class="xmasb_quotes_list">
			<?php
			foreach ($duplicates as $duplicate)
			{
				echo "<li>" . $duplicate->quote . "</li>";
				$sql = 'SELECT id, author
					FROM ' . XMASB_QUOTES_TABLE . '
					WHERE quote = "' . $duplicate->quote . '"';
				$authors = $wpdb->get_results($sql);				
				?><table><tbody><?php
				foreach ($authors as $author)
				{
					echo '<form action="" method="post"><tr>
						<td style="width:200px"><strong>' . $author->author . '</strong></td>
						<input type="hidden" name="mode" value="edit">
						<input type="hidden" value="' . $author->id . '" name="quoteID"/>
						<td><input class="button" type="submit" value="' . __('Edit') . '" name="Submit"/><input class="button" type="submit" onclick="return delete_confirmation_xmasb_quotes()" value="Delete" name="mode"/></td>
					</form></li>';
				}
				?></tbody></table><?php
			}
			?>
			</ul>
			</div>
			<?php
		}
		?>
		<?php
	}
	else
	{
	?>
		<form name="quotelist" id="quotelist" method="post" action="">
			<input type="hidden" name="mode" value="new">
			<input class="button" type="submit" value="<?php _e('Add New Quote') ?>" name="Submit"/>
		</form>
	<?php
	}
	?>
		</div>
	<?php
}

# Include CSS/JS in the HEAD of the html page
function xmasb_quotes_head_inclusion() {
	$siteurl = get_option("siteurl");
	if ($siteurl[strlen($siteurl)-1] != "/") $siteurl .= "/";
	$plugin_path = $siteurl . "wp-content/plugins/" . dirname(plugin_basename(__FILE__)) . "/";
	
	# CSS inclusion
	echo "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"" . $plugin_path;
	echo (is_plugin_page() ? "admin_page" : basename(__FILE__, ".php")) . ".css" . "\" />\n";

	# JS inclusion
	echo "<script type=\"text/javascript\" src=\"" . $plugin_path . "xmasbquotes.js\"></script>\n";
}

/*
Widget code
*/

function widget_xmasb_quotes_init()
{
	load_plugin_textdomain('xmasb_quotes', "/wp-content/plugins/xmasbquotes/");
	
	if ( !function_exists('register_sidebar_widget') )
			return;

	function widget_xmasb_quotes($args)
	{
			extract($args);

			$options = get_option('widget_xmasb_quotes');
			$title = $options['title'];

			echo $before_widget . $before_title . $title . $after_title;

			if ( !function_exists('xmasb_get_random_quote') )
			{
			?>
					<div class="wp-xmasb_quotes-error">Cannot find the XmasB quotes plugin. If you have installed it check if you have activated it. If you have not installed it, you can download it from <a title="XmasB Quotes" href="http://xmasb.com">xmasb.com</a>.</div>
			<?php
			}
			else
			{
				xmasb_print_random_quote();
			}

			echo $after_widget;
	}

	function widget_xmasb_quotes_control()
	{
		$options = get_option('widget_xmasb_quotes');
		if ( !is_array($options) )
			$options = array('title'=>'XmasB Quotes', 'showimages'=>'yes', 'defaultimage'=>'quote.gif', 'showlink'=>'yes');
		if ( $_POST['xmasb_quotes-submit'] )
		{
			$options['title'] = strip_tags(stripslashes($_POST['xmasb_quotes-title']));
			update_option('widget_xmasb_quotes', $options);
		}

		$title = htmlspecialchars($options['title'], ENT_QUOTES);

		?>
		<p style="text-align:right;"><label for="xmasb_quotes-title">Title: <input style="width: 200px;" id="xmasb_quotes-title" name="xmasb_quotes-title" type="text" value="<?php echo $title; ?>" /></label></p>
		<input type="hidden" id="xmasb_quotes-submit" name="xmasb_quotes-submit" value="1" />
		<?php
	}

	register_sidebar_widget('XmasB Quotes', 'widget_xmasb_quotes');
	register_widget_control('XmasB Quotes', 'widget_xmasb_quotes_control', 300, 100);
}

# Add 'XmasB Quotes' page to Wordpress' Manage menu
function xmasb_quotes_add_management_page()
{
    if (function_exists('add_management_page'))
		{
		  add_management_page('XmasB Quotes', 'XmasB Quotes', 8, basename(__FILE__), 'xmasb_quotes_management_page');
    }
}

# Add 'XmasB Quotes' page to Wordpress' Options menu
function xmasb_quotes_add_opptions_page()
{
	if (function_exists('add_options_page'))
	{
		add_options_page('XmasB Quotes', 'XmasB Quotes', 8, basename(__FILE__), 'xmasb_quotes_options_page');
	}
}

function xmasb_quotes_add_pages()
{
	xmasb_quotes_add_management_page();
	xmasb_quotes_add_opptions_page();
}
# Init Widget
add_action('plugins_loaded', 'widget_xmasb_quotes_init');

# CSS/JS inclusion in HEAD
add_action('wp_head', 'xmasb_quotes_head_inclusion');
add_action('admin_head', 'xmasb_quotes_head_inclusion');

add_action('activate_' . dirname(plugin_basename(__FILE__)) . '/' . basename(plugin_basename(__FILE__)), 'xmasb_quotes_install');
add_action('admin_menu', 'xmasb_quotes_add_pages');

add_filter('the_content','filter_xmasb_quotes_random_quote');